#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <dmedia/audio.h>
#include <errno.h>

void get_offset(char *buf, int num);
static void Abandon(char *s);

void main(void)
{
  char mono, rate, width, format, urlFlag;
  char url[5][256], *buf, buf_out[255], buf_head[6]; 
  long offset[5], char_offset;
  FILE *fp, *fpadpcm;
  int n, i, Wrote, Read, j, num, time = 50;
  short *adpcm_buf;
  off_t fsize;
  int fd;

  strcpy(url[4], "http://pathfinder.com/@@auglGgUAItuxHVja/time/");
  strcpy(url[1], "http://www.npac.syr.edu/");
  strcpy(url[2], "http://155.246.89.81/~jrichey/agents.html");
  strcpy(url[3], "http://www.hns.com/HNS_home.html");
  strcpy(url[0],
	 "http://www.teachersoft.com/Library/ref/atlas/atlas.htm");

  mono = '1';
  rate = '1'; /* 1 -> 8000 Hz, 2 -> 11025 Hz, 3 -> 22KHz */
  width = (char)AL_SAMPLE_16; /* 8 bit adpcm file */
  format = (char)AL_SAMPFMT_TWOSCOMP; /* two's complement format*/
  urlFlag = '1';   /* 1 -> yes, 0 -> no */

  num = 5; /* number of URLs */

  buf_head[0] = mono;
  buf_head[1] = rate;
  buf_head[2] = width;
  buf_head[3] = format;
  buf_head[4] = urlFlag;    /* url present or not */
  buf_head[5] = (char)num; /* number of urls */

  fp = fopen("nov.adpcm", "w");
  if (!fp)
    Abandon("file open error");
  
  Wrote = fwrite(buf_head, (size_t) sizeof(char), (size_t) 6, fp);
  if (Wrote < 0) {
    fprintf(stderr, "errno = %d\n", errno);
    exit(1);
  }
  else
    printf("wrote = %d\n", Wrote);
  
  fclose(fp);
  if (urlFlag) {
    printf("entering loop\n");
    for (j = 0; j < num; j++) {
  
      n = strlen(url[j]);
      fprintf(stdout,"n = %d\n", n);
      
      offset[j] = 8000 * 2 * time*(j+1);
      printf("offset[%d] = %ld\n", j, offset[j]);
      
      buf = (char *) malloc((n+5) * sizeof(char)); 
      if (!buf) {
	fprintf(stderr, "memory allocation failure\n");
	exit(1);
      }
      
      buf[0] = (char) ( (n+1) + sizeof(long) );
      strcpy( buf+1, url[j]);
      
      char_offset = offset[j] & 0x000000ff;
      buf[n+4] = (char) char_offset;
      
      char_offset = offset[j] & 0x0000ff00;
      char_offset = char_offset >> 8;
      buf[n+3] = (char) char_offset;
      
      char_offset = offset[j] & 0x00ff0000;
      char_offset = char_offset >> 16;
      buf[n+2] = (char) char_offset;
      
      char_offset = offset[j] & 0xff000000;
      char_offset = char_offset >> 24;
      buf[n+1] = (char) char_offset;
      
      for (i = 0; i < n+5; i++)
	fprintf(stdout, "buf[%d] = %c = %d\n", i, buf[i], buf[i]);
      
      fp = fopen("nov.adpcm", "a");
      if (!fp) 
	Abandon("file open error");
      
      Wrote = fwrite(buf, (size_t) sizeof(char), (size_t) (n+5), fp);
      if (Wrote < 0) 
	Abandon("file write error for buf");
      else
	printf("Wrote  buf = %d\n", Wrote);
      
      fclose(fp);
      
      free(buf);
    }
  }

  fp = fopen("nov.adpcm", "r");

  Read = fread(buf_out, (size_t) sizeof(char), (size_t)6, fp);
  printf("Read buf_head = %d\n", Read);

  for (j = 0; j < Read; j++)
    printf("buf_head[%d] = %c = %d\n", j, buf_out[j], buf_out[j]);
  if (urlFlag) {
    for (j = 0; j < num; j++) {
      /*    n = strlen(url[j]); */
      Read = fread(buf_out, (size_t) sizeof(char), (size_t) 1, fp);
      n = buf_out[0]; n--;
      Read = fread(buf_out+1, (size_t) sizeof(char), (size_t) n, fp);
      printf("Read = %d\n", Read);

      for (i = 0; i < Read+1; i++)
	fprintf(stdout, "buf_out[%d] = %c = %d\n", i, buf_out[i],
		buf_out[i]);
      
      get_offset(buf_out, Read);
      
    }
    fclose(fp);
  }

  fd = open("november_rain.adpcm", O_RDWR);
  if (fd == -1) {
    fprintf(stderr, "open: errno = %d\n", errno);
    exit(1);
  }
  
  fsize = lseek(fd, (off_t) 0, SEEK_END);
  if (fsize == -1) {
    fprintf(stderr, "lseek: errno = %d\n", errno);
    exit(1);
  }
  
  fprintf(stdout, "filesize = %ld\n", fsize);
  
  adpcm_buf = (short *) malloc(fsize*2);
  if (!adpcm_buf) {
    fprintf(stderr, "adpcm_buf: memory allocation failure\n");
    exit(1);
  }
  lseek(fd, (off_t) 0, SEEK_SET);
  Read = read(fd, (void *)adpcm_buf, fsize);
  if (Read == -1) {
    fprintf(stderr, "read: errno = %d\n", errno);
    exit(1);
  }

  close(fd);
  
  fp = fopen("nov.adpcm", "a");
  Wrote = fwrite(adpcm_buf, (size_t) sizeof(short), (size_t)
		 (fsize/sizeof(short)), fp);
  if (Wrote == -1) {
    fprintf(stderr, "fwrite: errno = %d\n", errno);
    exit(1);
  }
  
  fclose(fp);
  
}

void get_offset(char *buf, int num)
{
  long char_offset;
  long out_offset;

  out_offset = buf[num];

  char_offset = buf[num-1];
  char_offset = char_offset << 8;
  out_offset = out_offset | char_offset;

  char_offset = buf[num-2];
  char_offset = char_offset << 16;
  out_offset = out_offset | char_offset;

  char_offset = buf[num-3];
  char_offset = char_offset << 24;
  out_offset = out_offset | char_offset;

  fprintf(stdout, "out_offset = %ld\n", out_offset);

  
}

static void Abandon(char *s)
{
  fprintf(stderr, "fatal error: %s\n",s);
  exit(1);
}
